#!/bin/sh

# Setup script for fglrx driver
# FIXME: this should use libsax-perl like the intel one, but libsax
# (a) doesn't let you tweak Extensions, and (b) chokes on "agplock=0"

case "$*" in
-n)
	make_changes=0
	;;
*)
	make_changes=1
	;;
esac

function check_fglrx_driver {
    grep -q 'Driver[ 	]*"fglrx"' /etc/X11/xorg.conf
}

function check_xorg_option {
    section="$1"
    option="$2"
    value="$3"

    perl -n -e \
	'if (/^Section "'"$section"'"/../^EndSection/) {
		if (/^\s*Option\s+"'"$option"'"\s+"'"$value"'"/) {
			exit 1;
		}
	}' /etc/X11/xorg.conf && return 1
    return 0
}

function set_xorg_option {
    section="$1"
    option="$2"
    value="$3"

    perl -ni -e \
	'if (/^Section "'"$section"'"/../^EndSection/) {
		if (/^\s*Option\s+"'"$option"'"/) {
			print $& . " \"'"$value"'\"\n";
			$set = 1;
		} elsif (/^EndSection/ && !$set) {
			print "  Option       \"'"$option"'\" \"'"$value"'\"\n";
			print;
		} else {
			print;
		}
	} else {
		print;
	}' /etc/X11/xorg.conf
}

function xorg_option {
    if [ $make_changes = 1 ]; then
	set_xorg_option "$@"
    else
	check_xorg_option "$@"
    fi
}



# Make sure we're using the fglrx driver
if ! check_fglrx_driver; then
    if [ `id -u` = 0 -a $make_changes = 1 ]; then
	sax2 -r -m0=fglrx
    fi

    if ! check_fglrx_driver; then
	exit 1
    fi
fi

# Some options that are needed for at least some cards...
if ! xorg_option Device EnablePrivateBackZ no; then
    exit 1
fi
if ! xorg_option Device KernelModuleParm agplock=0; then
    exit 1
fi

# qv bug 173180, remove when that's fixed
if ! xorg_option Extensions DAMAGE no; then
    exit 1
fi

exit 0
